- name: check for legacy Terraform structure
  ansible.builtin.stat:
    path: "{{ context }}/terraform.tfstate"
  register: legacy_tf

- name: preparing Terraform
  block:
    - name: showing migration info
      debug:
        msg: "Migrating to new Terraform structure"

    - name: copying Terraform files
      copy:
        src: "{{ context }}/{{ item }}"
        dest: "{{ context }}/terraform/{{ item }}"
      with_items:
        - main.tf
        - variables.tf
        - versions.tf
        - .terraform.lock.hcl
        - "{{ cloudstack.stack.name }}.tfvars"
        - terraform.tfstate
        - terraform.tfstate.backup
        - variables.tf
      ignore_errors: True

    - name: Copy legacy Terraform templates
      copy:
        src: "{{ context }}/templates"
        dest: "{{ context }}/terraform"
      ignore_errors: True

    - name: remove legacy templates directory
      ansible.builtin.file:
        path: "{{ context }}/templates"
        state: absent

    - name: copying legacy Terraform files
      ansible.builtin.file:
        path: "{{ context }}/{{ item }}"
        state: absent
      with_items:
        - main.tf
        - variables.tf
        - versions.tf
        - .terraform.lock.hcl
        - "{{ cloudstack.stack.name }}.tfvars"
        - terraform.tfstate
        - terraform.tfstate.backup
        - variables.tf
  when: legacy_tf.stat.exists
